---
title: How to resolve a dev-doc-needed bug
slug: MDN/Contribute/Howto/Resolve_a_dev-doc-needed_bug
tags:
  - Guide
  - Howto
  - MDN Meta
---
<div>{{MDNSidebar}}</div><p><a href="/en-US/docs/Mozilla/Bugzilla">Bugzilla</a> is a web-based application that is used to track all changes to all Mozilla software projects. Some bugs (flagged with the "dev-doc-needed" keyword) require changes to the documentation on MDN as well as changes to the source code. However, sometimes the comments and descriptions in bugs are obscure and it is difficult to understand what needs to be done on MDN. This page provides a description and example of the steps we use to update MDN.</p>

<h2 id="A_typical_JavaScript_update">A typical JavaScript update</h2>

<h3 id="MDN_Doc_bug_tracker">MDN Doc bug tracker</h3>

<p>The first step in addressing a bug with the "dev-doc-needed" keyword is to find a bug with the "dev-doc-needed" keyword. The <a href="https://docs.google.com/spreadsheets/d/1YVuD7bQBUMw7hAPafCxR7QmpD3ZmUQ2vaon7d6v2tww/edit?pli=1#gid=0" title="http://beta.elchi3.de/doctracker/#list=fx&amp;version=">MDN doc bug tracking sheet</a> is a spreadsheet that collects bugs that require updates on MDN, and provides additional comments from the MDN writers.</p>

<h3 id="Bugzilla">Bugzilla</h3>

<p>Your search in the doc bug tracking sheet might have returned <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=761495">bug #761495</a>. In Bugzilla, we see that <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=761495">bug #761495</a> has the title: "(harmony:inthelpers) add Number.isInteger/toInteger." This suggests a couple of things:</p>

<ul>
 <li>"(harmony:inthelpers)": "Harmony" is a new edition of <a href="http://en.wikipedia.org/wiki/ECMAScript">ECMAScript</a>, the parent language of which JavaScript is a dialect.</li>
 <li>"Number.isInteger/toInteger": This looks like shorthand for two object / method names.</li>
</ul>

<p>Scrolling through the bug comments, we eventually come to a link to the mozilla-central source-code repository:  <a href="https://hg.mozilla.org/mozilla-central/rev/0ac60eea3e4a">https://hg.mozilla.org/mozilla-central/rev/0ac60eea3e4a</a></p>

<h3 id="Investigating_the_source_code_in_the_bug">Investigating the source code in the bug</h3>

<p>Following the link shows the changes that were made in the source code. The description of the change ("add Number.isInteger and Number.toInteger") confirms that this is indeed a change to the {{jsxref("Number")}} object. It adds the <code>isInteger</code> and <code>toInteger</code> methods.</p>

<p>The third link in the list of changed files points to the relevant change in the source code (<code>jsnum.cpp</code>). (The other two links point to files that contain test cases.)</p>

<p>Scrolling down, we see the actual change itself. A comment tells us which version of the ECMAScript standard implemented the change ("// ES6 draft ES6 15.7.3.12"). If we search the internet for "ecmascript harmony number isinteger" we find the descriptions of the <code>isInteger</code> and <code>toInteger</code> methods in the <a href="http://wiki.ecmascript.org/doku.php?id=harmony:number.tointeger&amp;s=tointeger">ECMAScript Harmony specification</a>. This is the reference on which we can base our changes in MDN.</p>

<h3 id="Changes_on_MDN">Changes on MDN</h3>

<p>In MDN, we search for the JavaScript <a href="/en-US/docs/JavaScript/Reference/Global_Objects/Number" title="https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Global_Objects/Number"><code>Number</code> object</a>. In the Methods section of that page, we add the <code>isInteger</code> and <code>toInteger</code> methods. We note that the methods were added in version 16 of Firefox by changing the compatibility table.</p>

<p>In the <a href="/en-US/docs/Firefox_16_for_developers">Firefox 16 for developers</a> article on MDN, we note that these methods have been added to the <code>Number</code> object.</p>

<h3 id="Updating_Bugzilla">Updating Bugzilla</h3>

<p>Now that MDN has been updated to include the changes from the bug, we will update Bugzilla so people know what changed:</p>

<ul>
 <li>Remove the "dev-doc-needed" keyword.</li>
 <li>Add the "dev-doc-complete" keyword.</li>
 <li>Add a comment to the bug that includes links to any MDN pages that were changed.</li>
</ul>
